﻿Imports System.Reflection
Imports Syncfusion.UI.Xaml.Charts

Module GlobalFunctions

    ''' <summary>
    ''' Returns the min and max Y values within the X range.
    ''' </summary>
    Sub GetExtremes(Xstart As Double, [Xend] As Double, ByRef Ymax As Double, ByRef Ymin As Double, area As SfChart, inAxis As ChartAxis)

        Ymin = Double.MaxValue
        Ymax = Double.MinValue

        For Each series In area.VisibleSeries

            Dim ActualYAxis = CType(series.GetType().GetProperty("ActualYAxis", BindingFlags.GetProperty Or BindingFlags.NonPublic Or BindingFlags.Instance).GetValue(series), ChartAxis) 'get the y axis of the series

            If ActualYAxis Is inAxis Then

                If series.DataCount > 0 Then

                    ' Console.WriteLine(Now & " GetExtremes " & series.Name)
                    ' sw.Restart()

                    Dim startIndex As Integer = 0
                    Dim endIndex As Integer = series.DataCount - 1

                    If Not Xstart = Nothing Then
                        startIndex = CInt(Math.Ceiling(Xstart))
                    End If
                    If Not [Xend] = Nothing Then
                        endIndex = CInt(Math.Floor([Xend]))
                    End If

                    If series.DataCount - 1 < endIndex Then
                        endIndex = series.DataCount - 1
                    End If

                    If series.DataCount - 1 < startIndex Then
                        startIndex = series.DataCount - 1
                    End If


                    If GetType(XyDataSeries).IsAssignableFrom(series.GetType) Then

                        Dim YValues = CType(series.GetType().GetProperty("YValues", BindingFlags.GetProperty Or BindingFlags.NonPublic Or BindingFlags.Instance).GetValue(series), IList(Of Double))
                        For i As Integer = startIndex To endIndex
                            If Not Double.IsNaN(YValues(i)) Then
                                If YValues(i) > Ymax Then Ymax = YValues(i)
                                If YValues(i) < Ymin Then Ymin = YValues(i)
                            End If
                        Next

                    ElseIf GetType(RangeSeriesBase).IsAssignableFrom(series.GetType) Then

                        Dim YValues = CType(series.GetType().GetProperty("HighValues", BindingFlags.GetProperty Or BindingFlags.NonPublic Or BindingFlags.Instance).GetValue(series), IList(Of Double))
                        For i As Integer = startIndex To endIndex
                            If Not Double.IsNaN(YValues(i)) Then
                                If YValues(i) > Ymax Then Ymax = YValues(i)
                                If YValues(i) < Ymin Then Ymin = YValues(i)
                            End If
                        Next

                    ElseIf GetType(FinancialSeriesBase).IsAssignableFrom(series.GetType) Then

                        Dim YLowValues = CType(series.GetType().GetProperty("LowValues", BindingFlags.GetProperty Or BindingFlags.NonPublic Or BindingFlags.Instance).GetValue(series), IList(Of Double))
                        Dim YHighValues = CType(series.GetType().GetProperty("HighValues", BindingFlags.GetProperty Or BindingFlags.NonPublic Or BindingFlags.Instance).GetValue(series), IList(Of Double))
                        For i As Integer = startIndex To endIndex
                            If Not Double.IsNaN(YLowValues(i)) Then
                                If YLowValues(i) < Ymin Then Ymin = YLowValues(i)
                            End If
                            If Not Double.IsNaN(YHighValues(i)) Then
                                If YHighValues(i) > Ymax Then Ymax = YHighValues(i)
                            End If
                        Next

                    End If

                    '  Console.WriteLine("GetExtremes " & inAxis.Name & " " & sw.ElapsedMilliseconds)
                End If


            End If
        Next

    End Sub


End Module
